package videoautomat;
import java.awt.Rectangle;

import sale.Action;
import sale.FormSheet;
import sale.FormSheetContentCreator;
import sale.SaleProcess;
import sale.SalesPoint;
import videoautomat.gui.Global;

/**
 * This class is an implementation of a <code>SalesPoint</code>, at which all the user
 * activities take place.
 *  
 */
public class VideoAutomat extends SalesPoint {
	/**
	 * The Constructor of VideoAutomat 
	 *  
	 */
	public VideoAutomat() {
		super(Global.CAPTION_AUTOMAT);
		setSalesPointFrameBounds(new Rectangle(0, 0, 640, 480));
	}

	/**
	 * @return the default <code>FormSheet</code> shown whenever no process is running.
	 * @see sale.SalesPoint#getDefaultFormSheet()
	 */
	protected FormSheet getDefaultFormSheet() {
		FormSheet fs =
			Global.getStartFormSheet(
				VideoShop.getVideoStock(),
				null,
				false,
				new TEDVideoStock());
		fs.addContentCreator(new FormSheetContentCreator() {
			protected void createFormSheetContent(FormSheet sheet) {
				sheet.getButton(Global.FB_LOGON).setAction(new Action() {
					public void doAction(SaleProcess process, SalesPoint point)
						throws Throwable {
						point.runProcess(new SaleProcessLogOn());
					}
				});
			}
		});
		return fs;
	}
	
}
