package videoautomat.gui;
import log.LogInputStream;
import log.stdforms.LogTableForm;
import sale.FormSheet;
import sale.FormSheetContentCreator;
/**
 * This class implements a <code>LogTableForm</code> to display the global logfile
 */
public class LogFileFormSheet extends LogTableForm {

	/**
	 * An ID to identify the <code>FormButton</code> close
	 */
	public static final int FB_CLOSE = 1;

	/**
	 * Constructs a new LogFileFormSheet
	 * 
	 * @param lis
	 *                  the <code>LogInputStream</code> to be used
	 */
	public LogFileFormSheet(LogInputStream lis) {
		super("Logged information", lis);

		addContentCreator(new FormSheetContentCreator() {
			public void createFormSheetContent(FormSheet fs) {
				fs.removeAllButtons();
				fs.addButton("Close", FB_CLOSE, null);
			}
		});
	}
}
